////////////////////////////
//
//	Clip-4-Win OFSTRUCT definitions
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifndef	C4W_OFS_CH
#define	C4W_OFS_CH


// Array elements of aOFS[], which is used with OpenFile()
//
// (these correspond to the members of the Windows OFSTRUCT structure)

#define	OFS_cBytes	1	// BYTE
#define	OFS_fFixedDisk	2	// BYTE
#define	OFS_nErrCode	3	// UINT
#define	OFS_reserved	4	// BYTE[4]
#define	OFS_szPathName	5	// char[128]

#define	OFS_LENGTH	5	// length of array

#define	OFS_A2BIN	"byte,byte,uint,string,string"		// for a2bin()
#define	OFS_BIN2A	"byte,byte,uint,string[4],string[128]"	// for bin2a()


// OpenFile() flags
#define	OF_READ			0
#define	OF_WRITE		1
#define	OF_READWRITE		2
#define	OF_SHARE_COMPAT		0
#define	OF_SHARE_EXCLUSIVE	16
#define	OF_SHARE_DENY_WRITE	32
#define	OF_SHARE_DENY_READ	48
#define	OF_SHARE_DENY_NONE	64
#define	OF_PARSE		256
#define	OF_DELETE		512
#define	OF_VERIFY		1024
#define	OF_SEARCH		1024
#define	OF_CANCEL		2048
#define	OF_CREATE		4096
#define	OF_PROMPT		8192
#define	OF_EXIST		16384
#define	OF_REOPEN		32768

#endif	// C4W_OFS_CH


////////////////////////////
//
//	Clip-4-Win DLL / CallDLL() definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifndef	C4W_DLL_CH
#define	C4W_DLL_CH

#xtranslate _NOREF_	=>
#xtranslate _NOREF_ @	=>

#xtranslate _LIB_(<lib>)						;
        =>  IIF(<lib> == "USER", "USER.EXE",				;
                IIF(<lib> == "GDI", "GDI.EXE",				;
                    IIF(<lib> == "KERNEL", "KERNEL.EXE", <lib> + ".DLL")))

#command _DLL [<static:STATIC>]						;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         [<callType:PASCAL,C>]:<lib>.<entryName>			;
									;
      => [<static>] FUNCTION <name>( _NOREF_ <p1> [, _NOREF_ <pN>] )	;
       ; LOCAL _cLib := UPPER( <(lib)> )				;
       ; LOCAL _hLib := LoadLibrary( _LIB_( _cLib ) )			;
       ; LOCAL _c := GetProcAddress( _hLib, <(entryName)>, <(callType)>,;
                                     <(returnType)>,			;
                                     <(type1)> [+"," + <(typeN)>] )	;
       ; LOCAL _uRet := CallDLL( _c [, <p1>] [, <pN>] )			;
       ; FreeLibrary( _hLib )						;
       ; RETURN _uRet


#endif	// C4W_DLL_CH
